=== modified file 'MANIFEST.in'
--- MANIFEST.in	2007-03-26 06:08:50 +0000
+++ MANIFEST.in	2008-06-22 18:04:15 +0000
@@ -1,4 +1,2 @@
-include dev.cfg loggerhead.conf.example README.txt NEWS
-recursive-include loggerhead/templates *.kid
-recursive-include loggerhead/config *.cfg
+include loggerhead.conf.example README.txt NEWS
 recursive-include loggerhead/static *

=== modified file 'NEWS'
--- NEWS	2008-03-06 01:59:26 +0000
+++ NEWS	2008-06-22 23:47:59 +0000
@@ -1,6 +1,48 @@
 What's changed in loggerhead?
 =============================
 
+1.6 [unreleased]
+----------------
+
+    - Loggerhead is no longer a TurboGears application, but rather a
+      WSGI application built using Paste (see http://wsgi.org/ and
+      http://pythonpaste.org/ for more about WSGI and Paste). XXX more.
+
+    - zpt.cleaner_urls bug 138021 ("loggerhead should generate links
+      based on revision numbers and file paths").  XXX more.
+
+    - The scripts no longer insist on Python 2.4 -- loggerhead works
+      fine with 2.5.
+
+    - Bazaar as of version 1.5 has improved in performance enough that
+      the revision cache no longer gave any noticeable benefit, so it
+      was removed (the files-changed cache is still useful).
+
+    - The templates were rewritten in Zope's TAL markup, powered by
+      the simpleTAL library -- improving both the performance and
+      memory consumption of rendering by a factor of around 3 for
+      large pages over the old Kid templates.
+
+    - Loggerhead's poorly performing text index was disabled.
+
+    - Loggerhead no longer depends on bzrlib functions deprecated in
+      Bazaar 1.5 and removed in 1.6 (Martin Albisetti).
+
+    - The daemonization code was made more regular, fixing bugs
+      #139161 ("Starting loggerhead process may not close its stdin
+      and stdout properly") and #211526 ("Codebrowse log directory has
+      unnecessarily permissive permissions")
+
+    - Some confusion about what the 'file_id' query argument means was
+      cleared up: filter_file_id now means "filter revisions to those
+      that affect this file" in all views and file_id means "examine
+      this file/directory" in the annotate and inventory views.
+
+    - Dates are present more compactly.
+
+    - The loggerhead.conf file can specify which network interface to
+      bind to (Mattias Eriksson)
+
 1.2.1  [06mar2008]
 ------------------
 

=== modified file 'README.txt'
--- README.txt	2008-06-20 04:58:42 +0000
+++ README.txt	2008-06-24 17:12:45 +0000
@@ -1,29 +1,69 @@
 LOGGERHEAD
 ==========
 
-[ Version 1.2 for Bazaar 1.2 ]
+[ Version 1.6 for Bazaar 1.6 ]
 
 Loggerhead is a web viewer for Bazaar branches.  It can be used to
 navigate a branch history, annotate files, perform searches... all the
 usual things.
 
-To get started, first you need to create a 'loggerhead.conf' file
-specifying the branches you want to view.  A 'loggerhead.conf.example'
-file is included in the source which has comments explaining the
-various options.
+
+GETTING STARTED
+---------------
+
+Loggerhead depends on SimpleTAL for templating and Paste for the
+server.  So you need these installed -- on Ubuntu you want the
+'python-simpletal' and 'python-paste' packages installed.  You need
+version 1.2 or newer of Paste.
+
+Then simply run the 'serve-branches.py' with the branch you want to
+serve on the command line:
+
+    ./serve-branches.py ~/path/to/branch
+
+The script listens on port 8080 so head to http://localhost:8080/ in
+your browser to see the branch.  You can also pass a directory that
+contains branches to the script, and it will serve a very simple
+directory listing at other pages.
+
+You may update the Bazaar branches being viewed at any time.
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+
+USING A CONFIG FILE
+-------------------
+
+Previous versions of Loggerhead read their configuration from a config
+file.  This mode of operation is still supported by the
+'start-loggerhead.py' script.  A 'loggerhead.conf.example' file is
+included in the source which has comments explaining the various
+options.
 
 Loggerhead can then be started by running::
 
     $ ./start-loggerhead.py
 
-This will run loggerhead in the background.  It listens on port 8080
-by default, so go to http://localhost:8080/ in your browser to see the
-list of bublished branches.
+This will run loggerhead in the background, listening on port 8080 by
+default.
 
 To stop Loggerhead, run::
 
     $ ./stop-loggerhead.py
 
+In the configuration file you can configure projects, and branches per
+project.  The idea is that you could be publishing several (possibly
+unrelated) projects through the same loggerhead instance, and several
+branches for the same project.  See the "loggerhead.conf.example" file
+included with the source.
+
+A debug and access log are stored in the logs/ folder, relative to
+the location of the start-loggerhead.py script.
+
+
+SERVING LOGGERHEAD FROM BEHIND APACHE
+-------------------------------------
+
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
 requests to Loggerhead.  Adding lines like this to you Apache
@@ -34,22 +74,11 @@
         ProxyPassReverse http://127.0.0.1:8080/
     </Location>
 
-In the configuration file you can configure projects, and branches per
-project.  The idea is that you could be publishing several (possibly
-unrelated) projects through the same loggerhead instance, and several
-branches for the same project.  See the "loggerhead.conf.example" file
-included with the source.
-
-Although Loggerhead is a TurboGears (http://www.turbogears.org)
-project, don't bother with "dev.cfg" or any of the other TurboGears
-config files.  Loggerhead overrides those values with its own.
-
-A debug and access log are stored in the logs/ folder, relative to
-the location of the start-loggerhead.py script.
-
-You may update the Bazaar branch at any time (for example, from a cron).
-Loggerhead will notice and refresh, and Bazaar uses its own branch
-locking to prevent corruption.
+If Paste Deploy is installed, the 'serve-branches.py' script can be
+run behind a proxy at the root of a site, but if you're running it at
+some path into the site, you'll need to add a 'prefix' argument to the
+PrefixMiddleware call in the script.  More flexible configuration
+should be added soon...
 
 
 FILES CHANGED CACHE
@@ -70,3 +99,6 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
+Bugs are tracked on Launchpad; start at:
+
+    https://bugs.launchpad.net/loggerhead

=== removed directory 'homepage'
=== removed directory 'homepage/download'
=== removed file 'homepage/download/loggerhead-1.0-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.0-0.13.tar.gz and homepage/download/loggerhead-1.0-0.13.tar.gz differ
=== removed file 'homepage/download/loggerhead-1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1-0.13.tar.gz and homepage/download/loggerhead-1.1-0.13.tar.gz differ
=== removed file 'homepage/download/loggerhead-1.1.1-0.13.tar.gz'
Binary files homepage/download/loggerhead-1.1.1-0.13.tar.gz and homepage/download/loggerhead-1.1.1-0.13.tar.gz differ
=== removed file 'homepage/index.html'
--- homepage/index.html	2007-01-24 23:39:39 +0000
+++ homepage/index.html	1970-01-01 00:00:00 +0000
@@ -1,74 +0,0 @@
-<html>
-<head>
-    <style type="text/css">
-@import "loggerhead.css";
-    </style>
-</head>
-<body>
-    <img src="loggerhead-logo-medium.png" />
-    
-    <p>
-    Loggerhead is a web viewer for projects in
-    <a href="http://www.bazaar-vcs.org/">bazaar</a>.
-    It can be used to navigate
-    a branch history, annotate files, view patches, perform searches, etc.
-    It's heavily based on 
-    <a href="https://launchpad.net/products/bzr-webserve">bazaar-webserve</a>,
-    which is itself based on
-    <a href="http://www.selenic.com/mercurial/wiki/index.cgi">hgweb</a> for
-    Mercurial.  The primary difference is that loggerhead is built on top of
-    <a href="http://www.turbogears.org/">TurboGears</a>.
-    </p>
-    
-    <p>
-    Loggerhead is released under the GPL license, and is written entirely
-    in python 2.4.
-    </p>
-    
-    <h2> News </h2>
-    
-    <ul>
-    <li> <span class="date"> 24 Jan 2007 </span> <br>
-        Loggerhead 1.1.1 released, to fix a paper-bag bug and a couple of
-        rendering quirks. </li>
-    <li> <span class="date"> 20 Jan 2007 </span> <br>
-        Loggerhead 1.1 released, with a lot of new features and improvements.
-        </li>
-    </ul>
-    
-    <h2> Download </h2>
-    
-    <p>
-    The current version is 1.1.1-0.13 (meaning 1.1.1, requiring bazaar 0.13),
-    released on 24 Jan 2006 at revision 109.
-    </p>
-    <ul class="downloads">
-    <li> <a href="download/loggerhead-1.1.1-0.13.tar.gz"> loggerhead-1.1.1-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 288af4396620443b7f2acd96a62ffbbf </span>
-        </li>
-    <li> <a href="download/loggerhead-1.1-0.13.tar.gz"> loggerhead-1.1-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 26194d00c72dbcaf63d14d9d099ee91e </span>
-        </li>
-    <li> <a href="download/loggerhead-1.0-0.13.tar.gz"> loggerhead-1.0-0.13.tar.gz </a>
-        <br /> <span class="md5"> MD5: 1b68c1dc6e13f9ed8f2b3ff0267cd8d9 </span>
-        </li>
-    </ul>
-    
-    <h2> Development </h2>
-    
-    <ul>
-    <li> project page on launchpad (for bug reports): <br />
-    <a class="link" href="https://launchpad.net/products/loggerhead/"> https://launchpad.net/products/loggerhead/ </a>
-    </li>
-
-    <li> development branch in bazaar: <br />
-    <a class="link" href="http://www.lag.net/robey/code/loggerhead/"> http://www.lag.net/robey/code/loggerhead/ </a>
-    </li>
-
-    <li> browse the source in loggerview: <br />
-    <a class="link" href="http://www.lag.net/branches/loggerhead/loggerhead_dev/"> http://www.lag.net/branches/loggerhead/loggerhead_dev/ </a>
-    </li>
-    </ul>	
-    
-</body>
-</html>

=== removed file 'homepage/loggerhead-background.png'
Binary files homepage/loggerhead-background.png and homepage/loggerhead-background.png differ
=== removed file 'homepage/loggerhead-logo-medium.png'
Binary files homepage/loggerhead-logo-medium.png and homepage/loggerhead-logo-medium.png differ
=== removed file 'homepage/loggerhead.css'
--- homepage/loggerhead.css	2007-01-24 23:39:39 +0000
+++ homepage/loggerhead.css	1970-01-01 00:00:00 +0000
@@ -1,50 +0,0 @@
-body {
-    background: url("loggerhead-background.png"); 
-    margin: 0px;
-    font-family: "Lucida Grande", Helvetica;
-    line-height: 1.4em;
-}
-img {
-    border: none;
-}
-p,ul {
-    margin-left: 2em;
-    width: 70%;
-}
-
-a {
-    text-decoration: none;
-    color: #204c90;
-}
-a:hover {
-    text-decoration: underline;
-}
-
-h2 {
-    font-size: 100%;
-    margin-left: 2em;
-    margin-right: 2em;
-    margin-top: 1.5em;
-    border-bottom: solid 1px black;
-}
-
-ul {
-    list-style: url(sphere.png);
-}
-ul.downloads .md5 {
-    font-family: monospace;
-    margin-left: 2em;
-}
-li {
-	margin-bottom: 1em;
-}
-
-.link {
-	margin-left: 1em;
-}
-
-.date {
-    font-weight: bold;
-    font-size: smaller;
-    text-decoration: underline;
-}

=== removed file 'homepage/sphere.png'
Binary files homepage/sphere.png and homepage/sphere.png differ
=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2008-06-20 05:17:46 +0000
+++ loggerhead/apps/branch.py	2008-06-24 17:12:45 +0000
@@ -13,7 +13,6 @@
 from loggerhead.controllers.revision_ui import RevisionUI
 from loggerhead.controllers.atom_ui import AtomUI
 from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.bundle_ui import BundleUI
 from loggerhead.controllers.search_ui import SearchUI
 from loggerhead.history import History
 from loggerhead import util
@@ -67,7 +66,6 @@
         'revision': RevisionUI,
         'download': DownloadUI,
         'atom': AtomUI,
-        'bundle': BundleUI,
         'search': SearchUI,
         }
 

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2008-06-18 12:27:04 +0000
+++ loggerhead/apps/config.py	2008-06-23 01:03:34 +0000
@@ -68,13 +68,13 @@
             self._add_view(view_name, ConfigObj(), folder)
         self._auto_list = auto_list
 
-    def _get_branch_url(self, view, view_config):
+    def _get_branch_url(self, view, view_config, folder):
         url = view_config.get('url', None)
         if url is not None:
             return url
         url = self._config.get('url_prefix', None)
         if url is not None:
-            return posixpath.join(url, self._folder) + '/'
+            return posixpath.join(url, folder) + '/'
         return None
 
     def _get_description(self, view, view_config):
@@ -93,7 +93,7 @@
                 friendly_name = view_name
         view.friendly_name = friendly_name
         view.name = view_name
-        branch_url = self._get_branch_url(view, view_config)
+        branch_url = self._get_branch_url(view, view_config, view_name)
         if branch_url is not None:
             view.branch_url = branch_url
         view.description = self._get_description(view, view_config)

=== removed file 'loggerhead/branchview.py'
--- loggerhead/branchview.py	2008-06-20 04:58:42 +0000
+++ loggerhead/branchview.py	1970-01-01 00:00:00 +0000
@@ -1,160 +0,0 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-"""
-collection of configuration and objects related to a bazaar branch.
-"""
-
-import logging
-import posixpath
-import threading
-import urllib
-
-from loggerhead import util
-from loggerhead.changecache import FileChangeCache
-from loggerhead.history import History
-from loggerhead.controllers.changelog_ui import ChangeLogUI
-from loggerhead.controllers.atom_ui import AtomUI
-from loggerhead.controllers.revision_ui import RevisionUI
-from loggerhead.controllers.inventory_ui import InventoryUI
-from loggerhead.controllers.annotate_ui import AnnotateUI
-from loggerhead.controllers.download_ui import DownloadUI
-from loggerhead.controllers.bundle_ui import BundleUI
-from loggerhead.controllers.search_ui import SearchUI
-
-
-with_history_lock = util.with_lock('_history_lock', 'History')
-
-
-class BranchView (object):
-    def __init__(self, group_name, name, subfolder, absfolder, config,
-                 project_config, root_config):
-        self._group_name = group_name
-        self._name = name
-        self._folder = subfolder
-        self._absfolder = absfolder
-        self._config = config
-        self._project_config = project_config
-        self._root_config = root_config
-        self.log = logging.getLogger('loggerhead.%s' % (name,))
-
-        # branch history
-        self._history_lock = threading.RLock()
-        self._history = None
-
-        self.changes = ChangeLogUI(self)
-        self.revision = RevisionUI(self)
-        self.files = InventoryUI(self)
-        self.annotate = AnnotateUI(self)
-        self.download = DownloadUI(self)
-        self.atom = AtomUI(self)
-        self.bundle = BundleUI(self)
-        self.search = SearchUI(self)
-
-        # force history object to be loaded:
-        self.get_history()
-
-    config = property(lambda self: self._config)
-
-    name = property(lambda self: self._name)
-
-    group_name = property(lambda self: self._group_name)
-
-    def _get_friendly_name(self):
-        name = self._config.get('branch_name', None)
-        if name is not None:
-            return name
-        # try branch-specific config?
-        name = self.get_history().get_config().get_nickname()
-        if name is not None:
-            return name
-        return self._name
-
-    friendly_name = property(_get_friendly_name)
-
-    def _get_description(self):
-        description = self._config.get('description', None)
-        if description is not None:
-            return description
-        # try branch-specific config?
-        description = self.get_history().get_config().get_user_option('description')
-        return description
-
-    description = property(_get_description)
-
-    def _get_branch_url(self):
-        url = self._config.get('url', None)
-        if url is not None:
-            return url
-        # try to assemble one from the project, if an url_prefix was defined.
-        url = self._project_config.get('url_prefix', None)
-        if url is not None:
-            return posixpath.join(url, self._folder) + '/'
-        # try branch-specific config?
-        url = self.get_history().get_config().get_user_option('public_branch')
-        return url
-
-    branch_url = property(_get_branch_url)
-
-    @turbogears.expose()
-    def index(self):
-        raise HTTPRedirect(self.url('/changes'))
-
-    def get_config_item(self, item, default=None):
-        for conf in self._config, self._project_config, self._root_config:
-            if item in conf:
-                return conf[item]
-        return default
-
-    @with_history_lock
-    def get_history(self):
-        """
-        get an up-to-date History object, safely.  each page-view calls this
-        method, and normally it will get the same History object as on previous
-        calls.  but if the bazaar branch on-disk has been updated since this
-        History was created, a new object will be created and returned.
-        """
-        if (self._history is None) or self._history.out_of_date():
-            self.log.debug('Reload branch history...')
-            _history = self._history = History.from_folder(
-                self._absfolder, self._name)
-            cache_path = self._config.get('cachepath', None)
-            if cache_path is None:
-                # try the project config
-                cache_path = self._project_config.get('cachepath', None)
-            if cache_path is not None:
-                _history.use_file_cache(FileChangeCache(_history, cache_path))
-        return self._history
-
-    def url(self, elements, **kw):
-        "build an url relative to this branch"
-        if not isinstance(elements, list):
-            elements = [elements]
-        if elements[0].startswith('/'):
-            elements[0] = elements[0][1:]
-        elements = [urllib.quote(x) for x in elements]
-        return turbogears.url([ '/' + self.group_name, self.name ] + elements, **kw)
-
-    def context_url(self, elements, **kw):
-        "build an url relative to this branch, bringing along browsing context"
-        return self.url(elements, **util.get_context(**kw))
-
-    def last_updated(self):
-        h = self.get_history()
-        change = h.get_changes([ h.last_revid ])[0]
-        return change.date

=== removed file 'loggerhead/controllers/bundle_ui.py'
--- loggerhead/controllers/bundle_ui.py	2008-06-18 06:34:10 +0000
+++ loggerhead/controllers/bundle_ui.py	1970-01-01 00:00:00 +0000
@@ -1,64 +0,0 @@
-#
-# Copyright (C) 2006  Robey Pointer <robey@lag.net>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-#
-
-import time
-
-from paste import httpexceptions
-from paste.request import path_info_pop
-
-
-class BundleUI (object):
-
-    def __init__(self, branch):
-        # BranchView object
-        self._branch = branch
-        self.log = branch.log
-
-    def default(self, request, response):
-        # /bundle/<rev_id>/[<compare_rev_id>/]filename
-        z = time.time()
-        h = self._branch.history
-
-        h._branch.lock_read()
-        try:
-            args = []
-            while 1:
-                arg = path_info_pop(request.environ)
-                if arg is None:
-                    break
-                args.append(arg)
-            if len(args) < 1:
-                raise httpexceptions.HTTPMovedPermanently('../changes')
-            revid = h.fix_revid(args[0])
-            if len(args) >= 3:
-                compare_revid = h.fix_revid(args[1])
-            else:
-                compare_revid = None
-
-            try:
-                bundle_data = h.get_bundle(revid, compare_revid)
-            except:
-                self.log.exception('Exception fetching bundle')
-                raise httpexceptions.HTTPServerError('Could not fetch bundle')
-
-            response.headers['Content-Type'] = 'application/octet-stream'
-            response.headers['Content-Length'] = len(bundle_data)
-            response.write(bundle_data)
-            self.log.info('/bundle: %r seconds' % (time.time() - z,))
-        finally:
-            h._branch.unlock()

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-06-20 05:50:14 +0000
+++ loggerhead/history.py	2008-06-24 17:12:45 +0000
@@ -41,7 +41,6 @@
 
 import bzrlib
 import bzrlib.branch
-import bzrlib.bundle.serializer
 import bzrlib.diff
 import bzrlib.errors
 import bzrlib.progress
@@ -656,7 +655,7 @@
         entry = {
             'revid': revision.revision_id,
             'date': commit_time,
-            'author': revision.committer,
+            'author': revision.get_apparent_author(),
             'branch_nick': revision.properties.get('branch-nick', None),
             'short_comment': short_message,
             'comment': revision.message,
@@ -869,11 +868,14 @@
             file_list.append(file)
 
         if sort_type == 'filename' or sort_type is None:
-            file_list.sort(key=lambda x: x.filename)
+            file_list.sort(key=lambda x: x.filename.lower()) # case-insensitive
         elif sort_type == 'size':
             file_list.sort(key=lambda x: x.size)
         elif sort_type == 'date':
             file_list.sort(key=lambda x: x.change.date)
+        
+        # Always sort by kind to get directories first
+        file_list.sort(key=lambda x: x.kind != 'directory')
 
         parity = 0
         for file in file_list:
@@ -926,15 +928,3 @@
             lineno += 1
 
         self.log.debug('annotate: %r secs' % (time.time() - z,))
-
-    @with_branch_lock
-    def get_bundle(self, revid, compare_revid=None):
-        if compare_revid is None:
-            parents = self._revision_graph[revid]
-            if len(parents) > 0:
-                compare_revid = parents[0]
-            else:
-                compare_revid = None
-        s = StringIO()
-        bzrlib.bundle.serializer.write_bundle(self._branch.repository, revid, compare_revid, s)
-        return s.getvalue()

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-06-20 02:20:05 +0000
+++ loggerhead/templates/revision.pt	2008-06-23 22:22:01 +0000
@@ -43,12 +43,6 @@
               view history from revision <tal:b content="change/revno" />
             </a>
           </div>
-          <div tal:condition="python:compare_revid is not None" >
-            <b>&#8594;</b>
-            <a tal:attributes="href python:branch.url(['/bundle', change.revno, history.get_revno(compare_revid), 'bundle.txt'])">
-                download bundle from <tal:b content="python:history.get_revno(compare_revid)" /> to <tal:b content="change/revno" />
-            </a>
-          </div>
           <div tal:condition="python:(remember is not None) and (compare_revid is None) and remember != revid" >
             <b>&#8594;</b>
             <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">

=== removed file 'push-website'
--- push-website	2007-01-24 18:43:51 +0000
+++ push-website	1970-01-01 00:00:00 +0000
@@ -1,7 +0,0 @@
-#!/bin/bash
-#
-# this is only useful for robey.  it updates the public website.
-#
-
-rsync -avr homepage/ robey@green.lag.net:/web/loggerhead
-

=== modified file 'serve-branches.py' (properties changed: -x to +x)
--- serve-branches.py	2008-06-18 07:35:18 +0000
+++ serve-branches.py	2008-06-23 02:23:46 +0000
@@ -1,15 +1,30 @@
+#!/usr/bin/env python
+import sys
+
+from paste import httpserver
+from paste.httpexceptions import HTTPExceptionHandler
+from paste.translogger import TransLogger
+
 from loggerhead.apps.filesystem import BranchesFromFileSystemRoot
-from paste import httpserver
-from paste.httpexceptions import make_middleware
-from paste.translogger import make_filter
-
-app = BranchesFromFileSystemRoot('.')
-
-app = app
-app = make_middleware(app)
-app = make_filter(app, None)
+
+if len(sys.argv) > 1:
+    path = sys.argv[1]
+else:
+    path = '.'
+
+app = BranchesFromFileSystemRoot(path)
+
+app = HTTPExceptionHandler(app)
+app = TransLogger(app)
+
+try:
+    from paste.deploy.config import PrefixMiddleware
+except ImportError:
+    pass
+else:
+    app = PrefixMiddleware(app)
 
 #from paste.evalexception import EvalException
 #app = EvalException(app)
 
-httpserver.serve(app, host='0.0.0.0', port='9876')
+httpserver.serve(app, host='0.0.0.0', port='8080')

=== modified file 'start-loggerhead.py'
--- start-loggerhead.py	2008-06-20 04:58:42 +0000
+++ start-loggerhead.py	2008-06-24 17:12:45 +0000
@@ -2,9 +2,10 @@
 
 import logging
 import logging.handlers
+from optparse import OptionParser
 import os
 import sys
-from optparse import OptionParser
+import urlparse
 
 from configobj import ConfigObj
 
@@ -121,11 +122,11 @@
     app = make_filter(app, None)
 
     if webpath:
-        if not webpath.endswith('/'):
-            webpath += '/'
-        def app(environ, start_response, app=app):
-            environ['SCRIPT_NAME'] = webpath
-            return app(environ, start_response)
+        scheme, netloc, path, blah, blah, blah = urlparse.urlparse(webpath)
+        def app(environ, start_response, orig=app):
+            environ['SCRIPT_NAME'] = path
+            environ['HTTP_HOST'] = netloc
+            return orig(environ, start_response)
 
     try:
         httpserver.serve(

